﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'mcStrongPasswordGenerator 1.0
Private Sub Class_Globals
	Private Alpha As String
	Private AlphaUpper As String
	Private Numeric As String
	Private Special As String
	Private Chars As String
	Private password As String
	
	Private useAlpha, useAlphaUpper, useNumeric, useSpecial  As Boolean
	Private PassLen,charsLength, rndNum As Int		
End Sub

'
'passLength: Your desired password Length as integer
'lowerAZ: if set to TRUE will use lowercase alphabets from A TO Z
'upperAZ: if set to TRUE will use UPPERCASE alphabets from A TO Z
'num09: if set to TRUE will use NUMBERS from 0 to 9
'specialChars: if set to TRUE will use SPECIAL CHARACTERS LIKE signs,brackets, comma, etc
'
Public Sub Initialize(passLength As Int,lowerAZ As Boolean,upperAZ As Boolean, num09 As Boolean,specialChars As Boolean)

	PassLen = passLength
	useAlpha = lowerAZ
	useAlphaUpper = upperAZ
	useNumeric = num09
	useSpecial = specialChars


	Alpha = "abcdefghijklmnopqrstuvwxyz"
	AlphaUpper = Alpha.ToUpperCase
	Numeric = "0123456789"
	Special = ".-+=_,!@$#*%<>[]{}"
	Chars = ""
End Sub

'Returns the randomly generated password
Public Sub generatePassword As String
	
	If  PassLen > 0 Then
		
		If useAlpha = True Then
			Chars = Chars & Alpha
		End If
		
		If useAlphaUpper = True Then
			Chars = Chars & AlphaUpper
		End If
		
		If useNumeric = True Then
			Chars = Chars & Numeric
		End If
		
		If useSpecial = True Then
			Chars = Chars & Special
		End If
		
		PassLen = PassLen
		'Log("Chosen: " & Chars)
	Else
		'Default Characters
		Chars = Alpha & AlphaUpper & Numeric
		PassLen = 8
		'Log("Default: " & Chars)
	
	End If
	
	charsLength = Chars.Length
	'Log("characters Length: " & charsLength)	
	password = ""


	For i = 1 To PassLen
		rndNum = Rnd(0,charsLength - 1)
		'Log("RND: " & rndNum)
	
		password =  password & Chars.CharAt(rndNum)
		'Log("PW: " & password)
	Next
	
	Return password
End Sub
